<?php
class DBCxn {
    // Jaki jest cig DSN poczenia?
    public static $dsn =
       array('zodiac' => 'sqlite:/usr/local/zodiac.db',
             'users' => array('mysql:host=db.przyklad.pl','monty','7f2iuh'),
             'stats' => array('oci:statistics', 'statsuser','statspass'));

    
    // Wewntrzna zmienna przechowujca uchwyt poczenia
    private static $db = array();
    // Klonowanie i powoywanie obiektu jest zabronione
    final private function __construct() { }
    final private function __clone() { }
    
    public static function get($key) {
        if (! isset(self::$dsn[$key])) {
            throw new Exception("Unknown DSN: $key");
        }
        // Zestawienie poczenia, jeli nie zostao ustanowione wczeniej
        if (! isset(self::$db[$key])) {
            if (is_array(self::$dsn[$key])) {
                // Dwie kolejne instrukcje dziaaj jedynie w PHP 5.1.3 i pniejszych
                // wersjach
                $c = new ReflectionClass('PDO');
                self::$db[$key] = $c->newInstanceArgs(self::$dsn[$key]);
            } else {
                self::$db[$key] = new PDO(self::$dsn[$key]);
            }
        }
        // Zwrcenie zmiennej poczenia
        return self::$db[$key];
    }
}
?>
